# How to contribute

Your contributions to the Stellar network will help improve the world’s financial
infrastructure, faster.

We want to make it as easy as possible to contribute changes that
help the Stellar network grow and thrive. There are a few guidelines that we
ask contributors to follow so that we can merge your changes quickly.

## Getting Started

* Create a GitHub issue for your contribution, assuming one does not already exist.
  * Clearly describe the issue including steps to reproduce if it is a bug.
* Fork the repository on GitHub

## Making Changes

* Create a topic branch from where you want to base your work.
  * This is usually the master branch.
  * Please avoid working directly on the `master` branch.
* Make sure you have added the necessary tests for your changes, and make sure all tests pass.

## Submitting Changes

* <a href="https://docs.google.com/forms/d/1g7EF6PERciwn7zfmfke5Sir2n10yddGGSXyZsq98tVY/viewform?usp=send_form">Sign the Contributor License Agreement</a>.
* All content, comments, and pull requests must follow the [Stellar Community Guidelines](https://www.stellar.org/community-guidelines/). 
* Push your changes to a topic branch in your fork of the repository.
* Submit a pull request to the [stellar-core-backup repository](https://github.com/stellar/stellar-core-backup) in the Stellar organization.
 * Include a descriptive [commit message](https://github.com/erlang/otp/wiki/Writing-good-commit-messages).
 * Changes contributed via pull request should focus on a single issue at a time.
 * Rebase your local changes against the master branch. Resolve any conflicts that arise.
 
At this point you're waiting on us. We like to at least comment on pull requests within three 
business days (and, typically, one business day). We may suggest some changes or improvements or alternatives.

## Making Trivial Changes

### Documentation
For changes of a trivial nature to comments and documentation, it is not
always necessary to create a new GitHub issue. In this case, it is
appropriate to start the first line of a commit with 'doc' instead of
an issue number. 

# Additional Resources

* [Bug tracker (Github)](https://github.com/stellar/stellar-core-backup/issues)
* <a href="https://docs.google.com/forms/d/1g7EF6PERciwn7zfmfke5Sir2n10yddGGSXyZsq98tVY/viewform?usp=send_form">Contributor License Agreement</a>
* [Readme for stellar-core-backup](https://github.com/stellar/stellar-core-backup/blob/master/README.md)
* #dev channel on [Slack](http://slack.stellar.org)


This document is inspired by:

https://github.com/puppetlabs/puppet/blob/master/CONTRIBUTING.md 

https://github.com/thoughtbot/factory_girl_rails/blob/master/CONTRIBUTING.md 

https://github.com/rust-lang/rust/blob/master/CONTRIBUTING.md
